module SKEIN_MIX_FUNCTION(x0, x1, Rj, Rd, y0, y1);

//{{{ input / output
input [63:0] x0;
input [63:0] x1;

input Rj;
input [2:0] Rd;

output [63:0] y0;
output [63:0] y1;
//}}}

//{{{ reg wire
reg [63:0] rotate;  //wire
//}}}

//{{{ wire assignment

//{{{rotate
always @(x1, Rd, Rj) begin
   if (~Rj) begin
      case(Rd)
         3'h0  :  rotate = {x1[58:0],x1[63:59]};
         3'h1  :  rotate = {x1[27:0],x1[63:28]};
         3'h2  :  rotate = {x1[50:0],x1[63:51]};
         3'h3  :  rotate = {x1[5:0],x1[63:6]};
         3'h4  :  rotate = {x1[37:0],x1[63:38]};
         3'h5  :  rotate = {x1[10:0],x1[63:11]};
         3'h6  :  rotate = {x1[52:0],x1[63:53]};
         3'h7  :  rotate = {x1[4:0],x1[63:5]};
         default  :  rotate = 0;
      endcase
   end
   else begin
      case(Rd)
         3'h0  :  rotate = {x1[7:0],x1[63:8]};
         3'h1  :  rotate = {x1[35:0],x1[63:36]};
         3'h2  :  rotate = {x1[17:0],x1[63:18]};
         3'h3  :  rotate = {x1[19:0],x1[63:20]};
         3'h4  :  rotate = {x1[43:0],x1[63:44]};
         3'h5  :  rotate = {x1[28:0],x1[63:29]};
         3'h6  :  rotate = {x1[21:0],x1[63:22]};
         3'h7  :  rotate = {x1[13:0],x1[63:14]};
         default  :  rotate = 0;
      endcase
   end
end
//}}}

assign y0 = x0 + x1;
assign y1 = y0 ^ rotate;

//}}}

endmodule

// vim:fdm=marker
